// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:crud_bloc_example/models.dart';
import 'package:wyatt_crud_bloc/wyatt_crud_bloc.dart';

class UserCubit extends CrudCubit<User> {
  final CrudRepository<User> _crudRepository;

  UserCubit(this._crudRepository);

  @override
  Create<User>? get crudCreate => Create(_crudRepository);

  @override
  Delete<User>? get crudDelete => Delete(_crudRepository);

  @override
  DeleteAll<User>? get crudDeleteAll => DeleteAll(_crudRepository);

  @override
  Get<User>? get crudGet => Get(_crudRepository);

  @override
  GetAll<User>? get crudGetAll => GetAll(_crudRepository);

  @override
  Query<User>? get crudQuery => Query(_crudRepository);

  @override
  Update<User>? get crudUpdate => Update(_crudRepository);

  @override
  UpdateAll<User>? get crudUpdateAll => UpdateAll(_crudRepository);
}
